﻿-- ////////////////
-- Commande SLASH
-- ////////////////
SLASH_ATA1 = '/ata';
local function AtaCommand(msg, editbox)
	listeHF = 0;
	if msg == 'clean' then CleanTrackList()
	elseif msg == 'check' then CheckBestRaid()
	elseif msg == 'test' then CheckAchiev()
	--elseif msg == 'debug' then
		--AutoTrackerAchievementDB["debug"] = true;
	elseif msg == 'help' or msg == '' then
		print("AtA commands :");
		print("/ata {onyxia/archavon/malygos/sartha/naxx/ulduar/coliseum/icc}{10/25}");
		print("/ata {bwd,bot,tfw,firelands,ds}");
		-- print("Use '/ata check' to known the raid with less complete achievements.");
	elseif msg == 'bonus' then
		IdZone = GetCurrentMapAreaID();
		faction = UnitFactionGroup("player");
		Liste = BonusHF(IdZone,faction);
		if Liste ~= nil or Liste == 0 then AchievListTable(Liste); end
	elseif msg == 'config' then
		AutoTrackerAchievement:Show();
		if AutoTrackerAchievementDB["Arena"] == true then AutoTrackerAchievement_CheckButton1:SetChecked(true); end
		if AutoTrackerAchievementDB["Raid"] == true then AutoTrackerAchievement_CheckButton2:SetChecked(true); end
		if AutoTrackerAchievementDB["Quete"] == true then AutoTrackerAchievement_CheckButton3:SetChecked(true); end
		if AutoTrackerAchievementDB["Bonus"] == true then AutoTrackerAchievement_CheckButton4:SetChecked(true); end
		

	elseif msg == 'reset' then AutoTrackerAchievementDB = AutoTrackerAchievementDB_Defaut;
	else
		listeHF = RaidHFList(msg);
	end	
	-- Listing des HF
	if listeHF ~= 0 then
	SaveTrackList()
	CleanTrackList()
	AchievListTable(listeHF)
	end
end
SlashCmdList["ATA"] = AtaCommand;

-- ////////////////
-- Variables
-- ////////////////
local AutoTrackerAchievementDB_Defaut = {
["Arena"] = true,
["Raid"] = true,
["Quete"] = true,
["Bonus"] = true,
["debug"] = false,
}

-- ////////////////
-- Fonctions XML
-- ////////////////
function CheckButton1_OnClick() -- Arena
if AutoTrackerAchievementDB["Arena"] == true then AutoTrackerAchievementDB["Arena"] = false
else AutoTrackerAchievementDB["Arena"] = true end
if AutoTrackerAchievementDB["debug"] == true then print(AutoTrackerAchievementDB["Arena"]); end
end
function CheckButton2_OnClick() -- Raid
if AutoTrackerAchievementDB["Raid"] == true then AutoTrackerAchievementDB["Raid"] = false
else AutoTrackerAchievementDB["Raid"] = true end
if AutoTrackerAchievementDB["debug"] == true then print(AutoTrackerAchievementDB["Raid"]); end
end
function CheckButton3_OnClick() -- Quete
if AutoTrackerAchievementDB["Quete"] == true then AutoTrackerAchievementDB["Quete"] = false
else AutoTrackerAchievementDB["Quete"] = true end
if AutoTrackerAchievementDB["debug"] == true then print(AutoTrackerAchievementDB["Quete"]); end
end
function CheckButton4_OnClick() -- Bonus
if AutoTrackerAchievementDB["Bonus"] == true then AutoTrackerAchievementDB["Bonus"] = false
else AutoTrackerAchievementDB["Bonus"] = true end
if AutoTrackerAchievementDB["debug"] == true then print(AutoTrackerAchievementDB["Bonus"]); end
end
function Button1_OnClick()
AutoTrackerAchievement:Hide();
end
function Button2_OnClick()
if AutoTrackerAchievementDB["debug"] == true then print("Reset"); end
AutoTrackerAchievementDB = AutoTrackerAchievementDB_Defaut;
end

-- ////////////////
-- Processus passif
-- ////////////////

local function eventHandler(self, event, ...)
	if event == "VARIABLES_LOADED" then
		if AutoTrackerAchievementDB == nil then
			AutoTrackerAchievementDB = AutoTrackerAchievementDB_Defaut;
			print("Generation des variables");
		end
		
		--for key,value in pairs(AutoTrackerAchievementDB) do print(key,value) end
	end
	
	if event == "ZONE_CHANGED_NEW_AREA" then
		-- infos de base
		IdZone = GetCurrentMapAreaID();
		faction = UnitFactionGroup("player");
		difficulty = GetInstanceDifficulty();
		-- infos de fonctions
		IdCAT = CatHF(IdZone);
		listeHF = RaidHF(IdZone,difficulty);
		IdHF = QuestsHF(IdZone,faction);
		ListeBonus = BonusHF(IdZone,faction);
		
		if IdCAT ~= 0 and AutoTrackerAchievementDB["Arena"] then -- Pvp/Darkmoon
			SaveTrackList()
			CleanTrackList()
			AchievListCat(IdCAT)
		
		elseif listeHF ~= 0 and AutoTrackerAchievementDB["Raid"] then -- raids/donjons
			SaveTrackList()
			CleanTrackList()
			AchievListTable(listeHF)
			
		elseif IdHF ~= 0 and AutoTrackerAchievementDB["Quetes"] then -- quetes
			-- Suppression du HF zone
			if OLD_TRACKED ~= 0 and OLD_TRACKED ~= nil then
			RemoveTrackedAchievement(OLD_TRACKED)
			else
			CleanTrackList()
			end
			-- Info du HF de la zone
			OLD_TRACKED = AchievListID(IdHF);
			
			-- Quetes bonus
			if ListeBonus ~= nil and ListeBonus ~= 0 and AutoTrackerAchievementDB["Bonus"] then
				print("HF disponibles dans la zone.");
				AchievListTable(ListeBonus);
			end
		
		elseif IdHF == 0 and OLD_TRACKED ~= 0 and OLD_TRACKED ~= nil then
			RemoveTrackedAchievement(OLD_TRACKED)		
		
		elseif not (TRACKED == nil) then -- Zone non gérer
			CleanTrackList()
			for i=1,#TRACKED do
			AddTrackedAchievement(TRACKED[i])
			end
			TRACKED = nil;
		end
	end
end

-- FONCTION DE CHARGEMENT
function AutoTrackerAchievement_OnLoad(self)
print("Achievement Tracker : OK");
self:RegisterEvent("ADDON_LOADED");
self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
self:RegisterEvent("PLAYER_ENTERING_WORLD");
self:RegisterEvent("VARIABLES_LOADED");
self:SetScript("OnEvent", eventHandler);
end

-- FONCTIONS RECURRENTES
function CleanTrackList() 
local achievlisted = {GetTrackedAchievements()};	
for i=1,#achievlisted do
RemoveTrackedAchievement(achievlisted[i])
end
end

function SaveTrackList()
if (not TRACKED) then
TRACKED = {GetTrackedAchievements()};
for i=1,#TRACKED do
end
else
end
end

-- Fonction qui renvoie l'id du HF en fonction de la zone (pour les HF de quete)
function QuestsHF(IdZone,faction)
Neutral = {
	[16]  = 4896,  -- Arathi Highlands
	[17]  = 4900,  -- Badlands
	[475] = 1193,  -- Blade's Edge Mountains
	[19]  = 4909,  -- Blasted Lands
	[29]  = 4901,  -- Burning Steppes
	[640] = 4871,  -- Deepholm
	[101] = 4930,  -- Desolace
	[23]  = 4892,  -- Eastern Plaguelands
	[182] = 4931,  -- Felwood
	[492] = 40,    -- Icecrown
	[606] = 4870,  -- Mount Hyjal
	[479] = 1194,  -- Netherstorm
	[37]  = 4906,  -- Northern Stranglethorn
	[28]  = 4910,  -- Searing Gorge
	[473] = 1195,  -- Shadowmoon Valley
	[493] = 39,    -- Sholazar Basin
	[261] = 4934,  -- Silithus
	[38]  = 4904,  -- Swamp of Sorrows
	[161] = 4935,  -- Tanaris
	[673] = 4905,  -- The Cape of Stranglethorn
	[26]  = 4897,  -- The Hinterlands
	[495] = 38,    -- The Storm Peaks
	[61]  = 4938,  -- Thousand Needles
	[720] = 4872,  -- Uldum
	[201] = 4939,  -- Un'Goro Crater
	[22]  = 4893,  -- Western Plaguelands
	[281] = 4940,  -- Winterspring
	[467] = 1190,  -- Zangarmarsh
	[496] = 36,    -- Zul'Drak
	[858] = 6540,  -- Dread Wastes
	[810] = 6539,  -- Townlong Steppes
	[811] = 7315,  -- Vale of Eternal Blossoms
	[807] = 6301,  -- Valley of the Four Winds
}

Alliance = {
	[43]  = 4925,  -- Ashenvale
	[476] = 4926,  -- Bloodmyst Isle
	[486] = 33,    -- Borean Tundra
	[42]  = 4928,  -- Darkshore
	[488] = 35,    -- Dragonblight
	[34]  = 4907,  -- Duskwood
	[141] = 4929,  -- Dustwallow Marsh
	[121] = 4932,  -- Feralas
	[490] = 37,    -- Grizzly Hills
	[465] = 1189,  -- Hellfire Peninsula
	[491] = 34,    -- Howling Fjord
	[35]  = 4899,  -- Loch Modan
	[477] = 1192,  -- Nagrand
	[36]  = 4902,  -- Redridge Mountains
	[607] = 4937,  -- Southern Barrens
	[81]  = 4936,  -- Stonetalon Mountains
	[478] = 1191,  -- Terokkar Forest
	[700] = 4873,  -- Twilight Highlands
	[613] = 4869,  -- Vashj'ir
	[39]  = 4903,  -- Westfall
	[40]  = 4898,  -- Wetlands
	[857] = 6535,  -- Krasarang Wilds
	[809] = 6537,  -- Kun-Lai Summit
	[806] = 6300,  -- The Jade Forest
}

Horde = {
	[43]  = 4976,  -- Ashenvale
	[181] = 4927,  -- Azshara
	[486] = 1358,  -- Borean Tundra
	[488] = 1359,  -- Dragonblight
	[141] = 4978,  -- Dustwallow Marsh
	[121] = 4979,  -- Feralas
	[463] = 4908,  -- Ghostlands
	[490] = 1357,  -- Grizzly Hills
	[465] = 1271,  -- Hellfire Peninsula
	[24]  = 4895,  -- Hillsbrad Foothills
	[491] = 1356,  -- Howling Fjord
	[477] = 1273,  -- Nagrand
	[11]  = 4933,  -- Northern Barrens
	[21]  = 4894,  -- Silverpine Forest
	[607] = 4981,  -- Southern Barrens
	[81]  = 4980,  -- Stonetalon Mountains
	[478] = 1272,  -- Terokkar Forest
	[700] = 5501,  -- Twilight Highlands
	[613] = 4982,  -- Vashj'ir
	[857] = 6536,  -- Krasarang Wilds
	[809] = 6538,  -- Kun-Lai Summit
	[806] = 6534,  -- The Jade Forest
}

	if faction == "Alliance" then
	liste = Alliance;
	elseif faction == "Horde" then
	liste = Horde;
	else
	return 0
	end
	
	IdHF = 0
	
	if liste ~= nil then
		for key,value in pairs(liste) do
		if key == IdZone then
		IdHF = value
		end
		end
		
		if IdHF == 0 then
		for key,value in pairs(Neutral) do
		if key == IdZone then 
		IdHF = value
		end
		end
		end
	end

	return IdHF
end

-- Fonction qui renvoie la catégorie HF en fonction de la zone (pour les HF pvp et Sombrelune)
function CatHF(IdZone)
	--print("CatHF : " .. IdZone);
	-- Battleground
	if IdZone == 461 then return 14802 end -- "Arathi Basin"
	if IdZone == 401 then return 14801 end -- "Alterac Valley"
	if IdZone == 482 then return 14803 end -- "Eye of the Storm"
	if IdZone == 443 then return 14804 end -- "Warsong Gulch"
	if IdZone == 512 then return 14881 end -- "Strand of the Ancients"
	if IdZone == 501 then return 14901 end -- "Wintergrasp"
	if IdZone == 540 then return 15003 end -- "Isle of Conquest"
	if IdZone == 736 then return 15073 end -- "Battle for Gilneas"
	if IdZone == 626 then return 15074 end -- "Twin Peaks"
	if IdZone == 708 then return 15075 end -- "Tol Barad"
	-- ARENA
	if IdZone == -1 then return 165 end -- ARENA
	-- Darkmoon Fair
	if IdZone == 823 then return 15101 end
	return 0
end

-- Fonction qui liste les HF selon la zone (raids et donjons)
function RaidHF(IdZone,difficulty)
	-- Wrath of the Lich-King
	diff = 10
	if difficulty == 2 or difficulty == 4 or difficulty == 25 then diff = 25 end

	if IdZone == 718 and diff == 10 then return RaidHFList("onyxia10") end -- Onyxia10
	if IdZone == 718 and diff == 25 then return RaidHFList("onyxia25") end -- Onyxia25
	if IdZone == 532 and diff == 10 then return RaidHFList("archavon10") end -- Archavon10
	if IdZone == 532 and diff == 25 then return RaidHFList("archavon25") end -- Archavon25
	if IdZone == 527 and diff == 10 then return RaidHFList("malygos10") end -- Eye of Eternity10
	if IdZone == 527 and diff == 25 then return RaidHFList("malygos25") end -- Eye of Eternity25
	if IdZone == 531 and diff == 10 then return RaidHFList("sartha10") end -- Sartharion10
	if IdZone == 531 and diff == 25 then return RaidHFList("sartha25") end -- Sartharion25
	if IdZone == 535 and diff == 10 then return RaidHFList("naxx10") end -- Naxxramas10
	if IdZone == 535 and diff == 25 then return RaidHFList("naxx25") end -- Naxxramas25
	if IdZone == 529 and diff == 10 then return RaidHFList("ulduar10") end -- Ulduar10
	if IdZone == 529 and diff == 25 then return RaidHFList("ulduar25") end -- Ulduar25
	if IdZone == 543 and diff == 10 then return RaidHFList("coliseum10") end -- Coliseum10
	if IdZone == 543 and diff == 25 then return RaidHFList("coliseum25") end -- Coliseum25
	if IdZone == 604 and diff == 10 then return RaidHFList("icc10") end -- ICC10
	if IdZone == 604 and diff == 25 then return RaidHFList("icc25") end -- ICC25
	
	-- Cataclysm
	if IdZone == 754 then return RaidHFList("bwd") end -- BWD
	if IdZone == 758 then return RaidHFList("bot") end -- Twilights
	if IdZone == 773 then return RaidHFList("tfw") end -- tfw
	if IdZone == 800 then return RaidHFList("firelands") end -- TDF/Firelands
	if IdZone == 824 then return RaidHFList("ds") end -- DS
	
	-- Mists of Pandaria
	-- attente
	return 0
end

-- Sous fonction de RaidHF: Selectionne la liste des HFs de raids
function RaidHFList(Raid)
	-- Wrath of the Lich King
	onyxia10={4404,4402}
	onyxia25={4407,4405}
	archavon10 = {4016}
	archavon25 = {4017}
	malygos10={1874,2148}
	malygos25={1875,2149}
	sartha10={2049,2050,2051,624,2047}
	sartha25={2052,2053,2054,1877,2048}
	naxx10={1997,1858,1856,2178,2176,1996,2182,2146,2184,578}
	naxx25={2140,1859,1857,2179,2177,2139,2183,2147,2185,579}
	ulduar10={2907,2909,3056,2905,2911,2925,2927,2930,2923,2919,
	2933,3058,2937,2934,2931,2947,2945,2941,2940,2939,2951,2959,2953,
	2955,3006,3076,2961,3182,2963,2967,3176,2971,2977,2975,2973,
	2982,2980,3179,2989,3180,3138,3181,2996,3159,3015,3008,3012,
	3014,3003}
	ulduar25={2908,2910,3057,2906,2912,2926,2928,2929,2924,2921,
	3059,2938,2936,2932,2948,2946,2944,2943,2942,2952,2960,
	2954,2956,3007,3077,2962,3184,2965,2968,3183,2972,2978,2976,
	2974,2983,2981,3187,3237,3189,2995,3188,2997,3164,3016,3010,
	3013,3017,3002}
	coliseum10={3917,3797,3936,3996,3799,3800}
	coliseum25={3916,3813,3937,3997,3815,3816}
	icc25={4534,4535,4536,4537,4538,4577,4578,4582,4539,4579,4580,4581,4601}
	icc10={4610,4611,4612,4613,4614,4615,4616,4617,4618,4619,4620,4622,4621}
	
	-- Cataclysm
	bwd = {5306,5309,5307,5310,5308,4849,4842}
	bot = {4852,5312,5313,5311,4850}
	tfw = {5304,5305,4851}
	firelands = {5810,5813,5829,5821,5855,5799,5830,5802}
	ds = {6174,6180,6128,6105,6133,6107,6175,6084}
	
	-- Tableau
	TableauHF = {["onyxia10"] = onyxia10,
	["onyxia25"] = onyxia25,
	["archavon10"] = archavon10,
	["archavon25"] = archavon25,
	["malygos10"] = malygos10,
	["malygos25"] = malygos25,
	["sartha10"] = sartha10,
	["sartha25"] = sartha25,
	["naxx10"] = naxx10,
	["naxx25"] = naxx25,
	["ulduar10"] = ulduar10,
	["ulduar25"] = ulduar25,
	["coliseum10"] = coliseum10,
	["coliseum25"] = coliseum25,
	["icc10"] = icc10,
	["icc25"] = icc25,
	["bwd"] = bwd,
	["bot"] = bot,
	["tfw"] = tfw,
	["firelands"] = firelands,
	["ds"] = ds}

	-- Retour des données
	if Raid == 'table' then return TableauHF end
	return TableauHF[Raid]
end

-- Fonction qui liste les HF bonus selon la zone (spécials)
function BonusHF(IdZone,faction)

Neutral = {
	[17]  = {5444,}, 	-- Terres Ingrates
	[181]  = {5454,5547,5448,5546,}, 	-- Azshara
	[281]  = {5443,}, 	-- Berceau
	[42] = {5453,}, -- Sombrivage
	[475] = {1276,}, -- Tranchante
	[478] = {1275,}, -- Terokkar
	[477] = {939,}, -- Nagrand
	[488] = {1277,547,}, -- Désolation des dragons
	[495] = {1428,}, -- Pics foudroyés
	[496] = {1596,}, -- Zul'drak
	[493] = {938,}, -- Bassin
	[486] = {561,}, -- Toudra
	[613]  = {4975,5452,}, 	-- Vashj'ir
	[606]  = {5869,4959,5864,5868,5861,5483,5865,5862,5860,}, 	-- Hyjal
	[640]  = {5445,5450,5446,5447,5449,}, 	-- Tréfond
	[700]  = {5451,4960,}, 	-- Hautes terres du Crépuscule
	[720]  = {4961,5317,}, 	-- Uldum
	[795]  = {5870,5872,5874,5859,5866,5871,5867,}, 	-- Front du magma
}

Alliance = {
	[700]  = {5320,5481,}, 	-- Hautes terres du Crépuscule
	[613]  = {5318,}, 	-- Vashj'ir
}

Horde = {
	[700]  = {5482,5321,}, 	-- Hautes terres du Crépuscule
	[613]  = {5319,}, 	-- Vashj'ir
}

	if faction == "Alliance" then
	liste = Alliance[IdZone];
	elseif faction == "Horde" then
	liste = Horde[IdZone];
	end
	
	ListeNeutre = Neutral[IdZone];
	
	if liste ~= nil then
	for i = 1, #liste do
	table.insert(ListeNeutre, liste[i])
	end
	end
	
	if ListeNeutre ~= nil then
	return ListeNeutre
	else
	return 0
	end
end

-- ////////////////
-- Afficheurs
-- ////////////////

-- Print the incomplete achievements in specific category
function AchievListCat(IdCAT)
local n
local currentlytracked = 0
local incomplete = false
id = IdCAT
for j = 1, GetCategoryNumAchievements(id) do
	aid, aname, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(id,j)
	if not completed then
		-- print (GetAchievementLink(aid));
		if currentlytracked < 10 then
		AddTrackedAchievement(aid);
		currentlytracked = currentlytracked +1
		end
		incomplete = true
	end
end
return incomplete
end

-- Print the incomplete achievements in specific list and and them to the tracking list
function AchievListTable(Liste)
	local currentlytracked = 0
	local incomplete = false
	for i=1,#Liste do
		aid, aname, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(Liste[i])
		if not completed then
			-- print(GetAchievementLink(aid));
				if currentlytracked < 10 then
					AddTrackedAchievement(aid);
					currentlytracked = currentlytracked +1
					end
			incomplete = true
		end
	end
	return incomplete
end

-- Print the incomplete achievement quest in specific zone and them to the tracking list
function AchievListID(IdHF)
	aid, aname, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(IdHF);
	if not completed then
		AddTrackedAchievement(aid)
		OldId = aid
	else
		OldId = 0
	end
	return OldId
end

-- Trouver le raid le plus rentable en HF
function CheckBestRaid()
	-- Tableau des HF
	Tableau = RaidHFList('table');
	TableauNB = {};
	
	for i in pairs(Tableau) do
	TableauNB[i] = 0
		for j,v in pairs(Tableau[i]) do
		aid, aname, points, completed, month, day, year, description, flags, icon, rewardText, isGuildAch = GetAchievementInfo(v)
		if not completed then TableauNB[i] = TableauNB[i] + 1 end
		end
	end
	
	for i,v in pairs(TableauNB) do
		if v ~= 0 then print(i,v) end
	end
end